# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

%global extraversion 08

%global no_xs %(perl -e 'print $] < 5.010 ? 1 : 0;')

Name:		perl-version
Epoch:		3
Version:	0.99
Release:	608.%{__distinit}%{__distvers}
Summary:	Perl extension for Version Objects
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/version/
Source0:	http://search.cpan.org/CPAN/authors/id/J/JP/JPEACOCK/version-%{version}%{?extraversion}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
%if %{no_xs}
BuildArch:	noarch
%endif
# ============= Module Build ====================
BuildRequires:	perl(ExtUtils::MakeMaker) >= 6.17
BuildRequires:	perl(File::Spec)
# ============= Module Runtime ==================
# (nothing)
# ============= Test Suite ======================
BuildRequires:	perl(base)
BuildRequires:	perl(Carp)
BuildRequires:	perl(constant)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(File::Temp) >= 0.13
BuildRequires:	perl(IO::Handle)
BuildRequires:	perl(lib)
BuildRequires:	perl(locale)
BuildRequires:	perl(Module::CoreList) >= 2.76
BuildRequires:	perl(overload)
BuildRequires:	perl(parent) >= 0.221
BuildRequires:	perl(POSIX)
BuildRequires:	perl(Test::Harness)
BuildRequires:	perl(Test::More) >= 0.45
# ============= Module Runtime ==================
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Carp)

# Don't "provide" private Perl libs
%{?perl_default_filter}

# charstar, version::vpp and version::vxs are private modules (see bug #633775)
%global __provides_exclude %{?__provides_exclude:%__provides_exclude|}perl\\(charstar\\)
%global __provides_exclude %{?__provides_exclude:%__provides_exclude|}perl\\(version::vpp\\)
%global __provides_exclude %{?__provides_exclude:%__provides_exclude|}perl\\(version::vxs\\)

%description
Version objects were added to Perl in 5.10. This module implements version
objects for older version of Perl and provides the version object API for
all versions of Perl. All previous releases before 0.74 are deprecated and
should not be used due to incompatible API changes. Version 0.77 introduces
the new 'parse' and 'declare' methods to standardize usage. You are
strongly urged to set 0.77 as a minimum in your code.

%prep
%setup -q -n version-%{version}%{?extraversion}

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}" UNINST=0
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -type f -name '*.bs' -a -size 0 -exec rm -f {} ';'
%{_fixperms} %{buildroot}

%check
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes README
%if %{no_xs}
%doc %{perl_vendorlib}/version.pod
%dir %{perl_vendorlib}/version/
%doc %{perl_vendorlib}/version/Internals.pod
%{perl_vendorlib}/version.pm
%{perl_vendorlib}/version/regex.pm
%{perl_vendorlib}/version/vpp.pm
%else
%doc %{perl_vendorarch}/version.pod
%dir %{perl_vendorarch}/version/
%doc %{perl_vendorarch}/version/Internals.pod
%{perl_vendorarch}/auto/version/
%{perl_vendorarch}/version.pm
%{perl_vendorarch}/version/regex.pm
%{perl_vendorarch}/version/vpp.pm
%{perl_vendorarch}/version/vxs.pm
%endif
%{_mandir}/man3/version.3pm*
%{_mandir}/man3/version::Internals.3pm*

%changelog
* Mon Feb  3 2014 Paul Howarth <paul@city-fan.org> 3:0.99-608
- update to 0.9908:
  - more optimizations, also resolving CPAN RT#92438, CPAN RT#92540 and
    CPAN RT#92642

* Wed Jan 15 2014 Paul Howarth <paul@city-fan.org> 3:0.99-607
- update to 0.9907:
  - lots of optimizations of XS and C code and other minor tweaks
    (CPAN RT#91892, CPAN RT#91867, CPAN RT#91987, CPAN RT#92051)
- add runtime dependency on perl(Carp)

* Mon Jan  6 2014 Paul Howarth <paul@city-fan.org> 3:0.99-602
- update to 0.9906:
  - major rewrite of XS code to permit easier inclusion in core Perl; XS code
    is no longer supported for any Perl < v5.10, although the pure Perl code
    still works going back to 5.005_04
  - in addition, the version::vpp class is now completely independent and can
    be use'd exactly like the base version class; it is still better to use the
    base class for compatibility purposes
  - applied C89 compatibility fix to vxs.inc
  - added back support for $version::LAX and $version::STRICT
    (CPAN RT#88458, CPAN RT#91858, CPAN RT#91868)
- drop workaround for CPAN RT#76813, no longer needed
- package is noarch for Perl < v5.10
- use UNINST=0 to work around issues with 5.10 < Perl < 5.12

* Tue Sep  3 2013 Paul Howarth <paul@city-fan.org> 3:0.99-601
- update to 0.9904:
  - final upstream changes from bleadperl, resolving CPAN RT#87513 and
    CPAN RT#87983
- BR: perl(Module::CoreList) ≥ 2.76 for the test suite

* Sun Aug 18 2013 Paul Howarth <paul@city-fan.org> 3:0.99-600
- update to 0.9903:
  - upstream test changes from bleadperl
  - include version::vpp even when installing XS version
  - subtle locale test changes
- specify all dependencies
- filter provides of charstar and version::vpp

* Wed Mar  6 2013 Paul Howarth <paul@city-fan.org> 3:0.99-500
- update to 0.9902:
  - upstream test changes from bleadperl
  - support env PERL_ONLY=1 as well as --perl-only (CPAN RT#83509)
  - version::new with no arguments read past the end of the stack
    (CPAN RT#81085)

* Tue Sep 11 2012 Paul Howarth <paul@city-fan.org> 3:0.99-242
- update to 0.9901:
  - fix problem with short floating point alpha versions (e.g. 0.52_0)
    (CPAN RT#79259)
- workaround for CPAN RT#76813 not accepted upstream, so apply it only where
  needed (on perl 5.8.6)

* Wed Aug 29 2012 Paul Howarth <paul@city-fan.org> 3:0.99-241
- improve %%description
- classify buildreqs by usage
- BR: at least version 0.45 of perl(Test::More)
- BR: perl(base), perl(File::Spec), perl(File::Temp) ≥ 0.13,
  perl(IO::Handle), perl(lib) and perl(Test::Harness)

* Tue Jun 12 2012 Paul Howarth <paul@city-fan.org> 3:0.99-3
- perl 5.16 rebuild

* Fri Apr 27 2012 Paul Howarth <paul@city-fan.org> 3:0.99-2
- apply tweak from Father Chrysostomos for CPAN RT#76813

* Fri Apr 27 2012 Paul Howarth <paul@city-fan.org> 3:0.99-1
- update to 0.99:
  - missed a patch from bleadperl
- update patch for CPAN RT#76813, and only apply it for FC-4.i386

* Thu Apr 26 2012 Paul Howarth <paul@city-fan.org> 3:0.98-1
- update to 0.98:
  - apply patch from core Perl to prevent overflow with ludicrous versions
- BR: perl(Data::Dumper)
- add patch to skip tests that fail with Perl < 5.8.8 (CPAN RT#76813)

* Mon Mar 26 2012 Paul Howarth <paul@city-fan.org> 3:0.97-1
- update to 0.97:
  - minor tweak to locale test to skip if no locales are installed at all
- don't need to remove empty directories from buildroot
- drop support for distributions prior to FC-3:
  - don't need to define %%{perl_vendorarch}
  - use %%{_fixperms} macro rather than our own chmod incantation
  - use DESTDIR rather than PERL_INSTALL_ROOT

* Mon Feb  6 2012 Paul Howarth <paul@city-fan.org> 3:0.96-1
- update to 0.96:
  - merge in upstream changes from bleadperl
  - improved locale tests

* Sat Nov 12 2011 Paul Howarth <paul@city-fan.org> 3:0.95-1
- update to 0.95:
  - restore compatibility in replacement UNIVERSAL::VERSION with the behaviour
    of Perl 5.14.x, essentially by reverting the changes in Perl RT#95544
  - fix segfault error with strings that begin with 'v', especially the string
    'version' (CPAN RT#72365)
  - forbid all math operations on version objects in base class; this was
    already the case for XS code but the pure Perl was lacking (CPAN RT#70950)

* Sun Aug 21 2011 Paul Howarth <paul@city-fan.org> 3:0.94-1
- update to 0.94:
  - prevent DIE handlers in user code from tripping up loading version, and
    add test to ensure that handling is correct (CPAN RT#70260)
  - tweak POD and add LICENSE to Makefile.PL (CPAN RT#70120)

* Thu Jul 28 2011 Paul Howarth <paul@city-fan.org> 3:0.93-1
- update to 0.93:
  - fix problem with UNIVERSAL::VERSION noted by Father Chrysostomos
- filter version::vxs provide in distributions with rpm 4.9 onwards (#633775)

* Wed Jul 27 2011 Paul Howarth <paul@city-fan.org> 3:0.92-1
- update to 0.92:
  - forbid negative versions; make replacement UNIVERSAL::VERSION return the
    original $VERSION scalar if called without a requested version
    (Perl RT#95544)
  - rewrite code so that we just override all subs for Perl ≥ 5.9.0 (when
    version.pm was added to the core)

* Sun Jul 10 2011 Paul Howarth <paul@city-fan.org> 3:0.91-3
- rebuild for perl 5.14.1 in Rawhide

* Sun Jul 10 2011 Paul Howarth <paul@city-fan.org> 3:0.91-2
- fix dist tag for CentOS 6 and Scientific Linux

* Mon Jun  6 2011 Paul Howarth <paul@city-fan.org> 3:0.91-1
- update to 0.91:
  - fix compilation/linking on Strawberry Perl (CPAN RT#68611)

* Thu Jun  2 2011 Paul Howarth <paul@city-fan.org> 3:0.90-1
- update to 0.90:
  - make all tests pass even with older Test::More (CPAN RT#68588)
- drop upstreamed patch for test suite

* Tue May 31 2011 Paul Howarth <paul@city-fan.org> 3:0.89-1
- update to 0.89:
  - remove discussion of Build.PL (no longer supported) from README
    (CPAN RT#66206)
  - change behaviour of pure Perl qv/declare to match the core/XS behaviour: do
    not use parent's new() class for derived classes; this breaks
    encapsulation but it's justified because qv/declare is a very specific
    thing that shouldn't be casually overridden (unless you do it directly in
    the subclass)
- fix test suite for use with old Test::More versions
- nobody else likes macros for commands

* Thu Jan  6 2011 Paul Howarth <paul@city-fan.org> 3:0.88-2
- drop exclusion of version::Internals documentation from EL-6 package now
  that #597982 is resolved

* Tue Dec 21 2010 Paul Howarth <paul@city-fan.org> 3:0.88-1
- update to 0.88:
  - fix Makefile.PL to make Strawberry Perl happy (CPAN RT#63991)

* Fri Dec 10 2010 Paul Howarth <paul@city-fan.org> 3:0.87-1
- update to 0.87:
  - remove support for Build.PL to keep from introducing circular dependencies

* Sat Nov 27 2010 Paul Howarth <paul@city-fan.org> 3:0.86-1
- update to 0.86:
  - fix export of is_strict/is_lax and add strict/lax tests from core

* Tue Oct 26 2010 Paul Howarth <paul@city-fan.org> 3:0.85-1
- update to 0.85:
  - don't ship MYMETA.yml file in distro

* Mon Oct 25 2010 Paul Howarth <paul@city-fan.org> 3:0.84-1
- update to 0.84:
  - restore public API broken by 0.83

* Mon Oct 18 2010 Paul Howarth <paul@city-fan.org> 3:0.83-1
- update to 0.83:
  - install into correct post-@INC reordering location (site rather than core)
  - build correctly with Perl releases in the 5.9.{3..5} and 5.11.{0..4} ranges
  - merge changes from bleadperl
  - change vverify API and simplify usage
  - fix up support for non-magical v-strings in 5.6.2-5.8.0
  - XS code finally passes on all supported Perl releases!

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> 3:0.82-3
- rebuild for perl 5.12.1 in Rawhide

* Fri May 28 2010 Paul Howarth <paul@city-fan.org> 3:0.82-2
- fix dist tag for RHEL-6 Beta
- exclude version::Internals documentation from EL-6 package (#549306)

* Tue Apr 20 2010 Paul Howarth <paul@city-fan.org> 3:0.82-1
- update to 0.82
  - full version object support
  - patch for bug in Perl 5.10.0 core version support
  - sync with Perl 5.12.0
  - vastly improved regex definitions
  - completely rewrite pure Perl code to operate exactly like the XS code

* Thu Jan 21 2010 Paul Howarth <paul@city-fan.org> 3:0.80-1
- update to 0.80 (assertion patch upstreamed - CPAN RT#53594)

* Mon Jan 11 2010 Paul Howarth <paul@city-fan.org> 3:0.79-1
- update to 0.79 (match code that will be in Perl 5.12, but no API changes)
- add patch to fix compile errors due to bogus assertions (CPAN RT#53594)

* Wed Dec 23 2009 Paul Howarth <paul@city-fan.org> 3:0.78-3
- include version::Internals documentation again

* Mon Dec 21 2009 Paul Howarth <paul@city-fan.org> 3:0.78-2
- temporarily exclude version::Internals documentation due to conflict with
  Rawhide perl (#549306)
- dist tag for Rawhide no longer needs special-casing

* Fri Oct 23 2009 Paul Howarth <paul@city-fan.org> 3:0.78-1
- update to 0.78
  - improve v-string heuristics for Perl 5.8.0 and earlier (CPAN RT#50347)
  - DTRT when installing on top of Perl >= 5.10.0 releases (CPAN RT#49667)

* Tue Sep  8 2009 Paul Howarth <paul@city-fan.org> 3:0.77-3
- update to 0.7702
  - fix inconsistency between pure-perl and XS versions (CPAN RT#49348)
- mark pod files as %%doc
- use %%{?perl_default_filter} to remove shared object provides

* Wed Jul 29 2009 Paul Howarth <paul@city-fan.org> 3:0.77-2
- update to 0.7701
- drop failing test patch (fixed upstream, CPAN RT#48268)

* Mon Jul 27 2009 Paul Howarth <paul@city-fan.org> 3:0.77-1
- update to 0.77 (see Changes for details)
- add patch to skip failing test on Fedora, RHEL < 5 (perl < 5.8.8)
- run tests again in verbose mode if they fail

* Mon Apr  6 2009 Paul Howarth <paul@city-fan.org> 3:0.76-1
- bump epoch to 3 as per Fedora version

* Fri Mar  6 2009 Paul Howarth <paul@city-fan.org> 0.76-2
- filter out unwanted provides for perl shared objects
- update to SLES-compatible dist tag macros

* Fri Oct 31 2008 Paul Howarth <paul@city-fan.org> 0.76-1
- update to 0.76
- tweak dist tag macros to work on current Rawhide with three-part releasenum
- clarify license as GPL version 1 or later, or Artistic (i.e. same as perl)
- buildreq Test::More

* Wed Mar 21 2007 Paul Howarth <paul@city-fan.org> 0.71-1
- update to 0.71
- fix dist tag for development builds and Fedora 7 onwards
- fix argument order for find with -depth
- buildreq perl(ExtUtils::MakeMaker) instead of perl(Module::Build)
- shellbang fixes no longer needed

* Mon Jul 17 2006 Paul Howarth <paul@city-fan.org> 0.64-2
- import from Fedora Extras
- remove spurious shellbangs to shut rpmlint up

* Fri Jul  7 2006 Tom "spot" Callaway <tcallawa@redhat.com> 0.64-1
- bump to 0.64

* Fri Mar 31 2006 Tom "spot" Callaway <tcallawa@redhat.com> 0.59-1
- bump to 0.59

* Tue Feb 28 2006 Tom "spot" Callaway <tcallawa@redhat.com> 0.57-1
- bump to 0.57

* Mon Jan  9 2006 Tom "spot" Callaway <tcallawa@redhat.com> 0.51-3
- one sed line only, not global, using __perl

* Sun Jan  8 2006 Tom "spot" Callaway <tcallawa@redhat.com> 0.51-2
- clean up scripty bits of some .pm files

* Fri Jan  6 2006 Tom "spot" Callaway <tcallawa@redhat.com> 0.51-1
- bump to 0.51
- pod file is doc

* Fri Jan  6 2006 Tom "spot" Callaway <tcallawa@redhat.com> 0.50-2
- don't pass optflags twice
- remove .bs files

* Thu Jan  5 2006 Tom "spot" Callaway <tcallawa@redhat.com> 0.50-1
- Initial package for Fedora Extras
